﻿Imports OpenCvSharp
'Imports OpenCvSharp.CPlusPlus

Public Class Form1
    'カメラキャプチャーを用意
    Dim videoCapture As CvCapture = Cv.CreateCameraCapture(0)
    ' USBカメラのID
    Dim myCamera As Integer = 0
    'グローバル変数の用意
    Dim myEndFlag, myFrameNow, myFrameShift As Integer
    Dim myFrameMax As Integer = 310
    Dim myShiftTime As Integer = 20
    Dim myShiftMax As Integer = 300
    ' カメラのフレームを用意する 
    Dim myIpl As IplImage
    ' カメラのフレームを用意する 
    Dim myImage(myFrameMax + 1) As Image

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        'Cv.NamedWindow("Now", WindowMode.AutoSize)
        If videoCapture Is Nothing Then
            ' ここでカメラがない場合のエラー処理 
        End If
        While Cv.WaitKey(1) = -1
            myFrameNow = myFrameNow + 1
            Label1.Text = "起動まで " + CStr(myShiftTime - myFrameNow) + Chr(13) + "「応答なし」になっても、しばらく待ってください。"
            Label1.Update()
            If (myFrameNow > myShiftTime) Then
                Exit While
            End If
            ' カメラから1フレーム取得する 
            myIpl = Cv.QueryFrame(videoCapture)
            myImage(myFrameNow) = OpenCvSharp.Extensions.BitmapConverter.ToBitmap(myIpl)
            ' ウィンドウに画像を表示する
            'PictureBox2.Image = myImage(myFrameNow)
            myIpl.Dispose()

            'Cv.ShowImage("Now", myIpl)
        End While
        PictureBox1.Image = myImage(myFrameNow - 1)
        PictureBox2.Image = myImage(myFrameNow - 1)
        Timer1.Interval = 100
        Timer1.Enabled = True
        Label1.Visible = False
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        myEndFlag = -1
        myFrameNow = 0
        Me.Close()
    End Sub

    Private Sub btnUp_Click(sender As Object, e As EventArgs) Handles btnUp.Click
        myShiftTime = myShiftTime + 10
        If (myShiftTime > myShiftMax) Then
            myShiftTime = myShiftMax
        End If
        Label2.Text = CStr(Int(myShiftTime / 10)) + "秒後を表示"
    End Sub

    Private Sub btnDown_Click(sender As Object, e As EventArgs) Handles btnDown.Click
        myShiftTime = myShiftTime - 10
        If (myShiftTime < 10) Then
            myShiftTime = 10
        End If
        Label2.Text = CStr(Int(myShiftTime / 10)) + "秒後を表示"
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' フォームのクライアント領域のサイズからPictuerBox1の大きさをきめる
        PictureBox1.Height = Me.ClientSize.Height
        PictureBox1.Width = CInt(CDbl(Me.ClientSize.Height) * 4 / 3)
        myEndFlag = 0
        Label2.Text = CStr(Int(myShiftTime / 10)) + "秒後を表示"
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Dim myAnswer As Integer
        Timer1.Enabled = False
        Label1.Visible = False
        myAnswer = MsgBox("Webカメラを切り替えますか？", 4, "Webカメラ切替")
        If myAnswer = 6 Then
            '「はい」の場合
            myCamera = myCamera + 1
            If myCamera > 2 Then
                myCamera = 0
            End If
            Try
                videoCapture = Cv.CreateCameraCapture(myCamera)
                System.Threading.Thread.Sleep(500)
            Catch
                myCamera = 0
                MsgBox("カメラの切り替えができませんでした。" & Chr(13) & "はじめのカメラを表示します。", vbOKOnly Or vbExclamation, "Webカメラ切替")
                videoCapture = Cv.CreateCameraCapture(myCamera)
            End Try
            Timer1.Enabled = True
        Else
            '「いいえ」の場合
            Timer1.Enabled = True
        End If

    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If (Cv.WaitKey(1) = -1) Then
            myFrameNow = myFrameNow + 1
            If (myFrameNow >= myFrameMax) Then
                myFrameNow = 0
            End If
            ' カメラから1フレーム取得する 
            myIpl = Cv.QueryFrame(videoCapture)
            myImage(myFrameNow) = OpenCvSharp.Extensions.BitmapConverter.ToBitmap(myIpl)
            myIpl.Dispose()
            ' 表示を遅らせる
            myFrameShift = myFrameNow - myShiftTime
            If (myFrameShift < 0) Then
                myFrameShift = myFrameShift + myFrameMax
            End If
            Label3.Text = "作動中　" + CStr(myFrameNow)
            ' ウィンドウに画像を表示する
            'PictureBox1.Image.Dispose()
            PictureBox1.Image = myImage(myFrameShift)
            myImage(myFrameShift) = Nothing
            'PictureBox2.Image.Dispose()
            PictureBox2.Image = myImage(myFrameNow)
        End If
    End Sub

    Private Sub Form1_Resize(sender As Object, e As EventArgs) Handles Me.Resize
        PictureBox1.Height = Me.ClientSize.Height
        PictureBox1.Width = CInt(CDbl(Me.ClientSize.Height) * 4 / 3)
    End Sub

End Class
